Polygon

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Polygon

    java.lang.Object
      java.awt.Polygon

All Implemented Interfaces:
  Shape, Serializable

    public class Polygon

extends Object
implements Shape, Serializable

The `Polygon` class encapsulates a description of a closed, two-dimensional region within a coordinate space. This region is bounded by an arbitrary number of line segments, each of which is one side of the polygon. Internally, a polygon comprises of a list of (x, y) coordinate pairs, where each pair defines a vertex of the polygon, and two successive pairs are the endpoints of a line that is a side of the polygon. The first and final pairs of (x, y) points are joined by a line segment that closes the polygon. This `Polygon` is defined with an even-odd winding rule. (The even-odd rule specifies that a point lies inside the path if a ray drawn in any direction from that point to infinity is crossed by path segments an odd number of times.) This class's hit-testing methods, which include the `contains`, `intersects` and `inside` methods, use the insideness definition described in the `Shape` class comments.

Since:
  JDK1.0
Version:
  1.26, 07/24/98
Author:
  Sami Shaio, Herb Jellinek
See Also:
  `Shape`, Serialized Form

Field Summary
`int` | `npoints` The total number of points.
`int[]` | `xpoints` The array of x coordinates.
`int[]` | `ypoints` The array of y coordinates.

Constructor Summary
`Polygon()` Creates an empty polygon.
`Polygon(int[] xpoints, int[] ypoints, int npoints)` Constructs and initializes a `Polygon` from the specified parameters.

Method Summary
`void` | `addPoint(int x, int y)` Appends the specified coordinates to this `Polygon`.
`boolean` | `contains(int x, int y)` Determines whether the specified coordinates are inside this `Polygon`.
`boolean` | `contains(Point p)` Determines whether the specified `Point` is inside this `Polygon`.
`Rectangle` | `getBounds()` Gets the bounding box of this `Polygon`.
`void` | `invalidate()` Invalidates or flushes any internally-cached data that depends on the vertex coordinates of this `Polygon`.
`void` | `reset()` Resets this `Polygon` object to an empty polygon.
`void` | `translate(int deltaX, int deltaY)` Translates the vertices of the `Polygon` by `deltaX` along the x axis and by `deltaY` along the y axis.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### npoints

    public int npoints

  The total number of points. The value of `npoints` represents the number of valid points in this `Polygon` and might be less than the number of elements in `xpoints` or `ypoints`. This value can be NULL.

  See Also:
    `addPoint(int, int)`

### xpoints

    public int[] xpoints

  The array of x coordinates. The number of elements in this array might be more than the number of x coordinates in this `Polygon`. The extra elements allow new points to be added to this `Polygon` without re-creating this array. The value of `npoints` is equal to the number of valid points in this `Polygon`.

  See Also:
    `addPoint(int, int)`

### ypoints

    public int[] ypoints

  The array of y coordinates. The number of elements in this array might be more than the number of y coordinates in this `Polygon`. The extra elements allow new points to be added to this `Polygon` without re-creating this array. The value of `npoints` is equal to the number of valid points in this `Polygon`.

  See Also:
    `addPoint(int, int)`

Constructor Detail

### Polygon

    public Polygon()

  Creates an empty polygon.

### Polygon

    public Polygon(int[] xpoints,
                   int[] ypoints,
                   int npoints)

  Constructs and initializes a `Polygon` from the specified parameters.

  Parameters:
    `xpoints` - an array of x coordinates
    `ypoints` - an array of y coordinates
    `npoints` - the total number of points in the `Polygon`
  Throws:
    `NegativeArraySizeException` - if the value of `npoints` is negative.
    `IndexOutOfBoundsException` - if `npoints` is greater than the length of `xpoints` or the length of `ypoints`.
    `NullPointerException` - if `xpoints` or `ypoints` is `null`.

Method Detail

### reset

    public void reset()

  Resets this `Polygon` object to an empty polygon. The coordinate arrays and the data in them are left untouched but the number of points is reset to zero to mark the old vertex data as invalid and to start accumulating new vertex data at the beginning. All internally-cached data relating to the old vertices are discarded. Note that since the coordinate arrays from before the reset are reused, creating a new empty `Polygon` might be more memory efficient than resetting the current one if the number of vertices in the new polygon data is significantly smaller than the number of vertices in the data from before the reset.

  Since:
    1.4
  See Also:
    `invalidate()`

### invalidate

    public void invalidate()

  Invalidates or flushes any internally-cached data that depends on the vertex coordinates of this `Polygon`. This method should be called after any direct manipulation of the coordinates in the `xpoints` or `ypoints` arrays to avoid inconsistent results from methods such as `getBounds` or `contains` that might cache data from earlier computations relating to the vertex coordinates.

  Since:
    1.4
  See Also:
    `getBounds()`

### translate

    public void translate(int deltaX,
                          int deltaY)

  Translates the vertices of the `Polygon` by `deltaX` along the x axis and by `deltaY` along the y axis.

  Parameters:
    `deltaX` - the amount to translate along the x axis
    `deltaY` - the amount to translate along the y axis
  Since:
    JDK1.1

### addPoint

    public void addPoint(int x,
                         int y)

  Appends the specified coordinates to this `Polygon`.

  If an operation that calculates the bounding box of this `Polygon` has already been performed, such as `getBounds` or `contains`, then this method updates the bounding box.

  Parameters:
    `x` - the specified x coordinate
    `y` - the specified y coordinate
  See Also:
    `getBounds()`, `contains(java.awt.Point)`

### getBounds

    public Rectangle getBounds()

  Gets the bounding box of this `Polygon`. The bounding box is the smallest `Rectangle` whose sides are parallel to the x and y axes of the coordinate space, and can completely contain the `Polygon`.

  Specified by:
    `getBounds` in interface `Shape`
  Returns:
    a `Rectangle` that defines the bounds of this `Polygon`.
  Since:
    JDK1.1

### contains

    public boolean contains(Point p)

  Determines whether the specified `Point` is inside this `Polygon`.

  Parameters:
    `p` - the specified `Point` to be tested
  Returns:
    `true` if the `Polygon` contains the `Point`; `false` otherwise.

### contains

    public boolean contains(int x,
                            int y)

  Determines whether the specified coordinates are inside this `Polygon`.

  Parameters:
    `x` - the specified x coordinate to be tested
    `y` - the specified y coordinate to be tested
  Returns:
    `true` if this `Polygon` contains the specified coordinates, (x, y); `false` otherwise.
  Since:
    JDK1.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD